3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[--interactive | -i] [-v] [--force-rebase | -f] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
39 OK_TO_SKIP_PRE_REBASE
=
41 When you have resolved this problem run \"git rebase --continue\".
42 If you would prefer to skip this patch, instead run \"git rebase --skip\".
43 To restore the original branch and stop rebasing run \"git rebase --abort\".
48 dotest
="$GIT_DIR"/rebase-merge
51 diffstat
=$
(git config
--bool rebase.stat
)
55 allow_rerere_autoupdate
=
58 test -n "$prev_head" || die
"prev_head must be defined"
59 test -d "$dotest" || die
"$dotest directory does not exist"
61 unmerged
=$
(git ls-files
-u)
62 if test -n "$unmerged"
64 echo "You still have unmerged paths in your index"
65 echo "did you forget to use git add?"
69 cmt
=`cat "$dotest/current"`
70 if ! git diff-index
--quiet --ignore-submodules HEAD
--
72 if ! git commit
--no-verify -C "$cmt"
74 echo "Commit failed, please do not call \"git commit\""
75 echo "directly, but instead do one of the following: "
78 if test -z "$GIT_QUIET"
80 printf "Committed: %0${prec}d " $msgnum
83 if test -z "$GIT_QUIET"
85 printf "Already applied: %0${prec}d " $msgnum
88 if test -z "$GIT_QUIET"
90 git rev-list
--pretty=oneline
-1 "$cmt" |
sed -e 's/^[^ ]* //'
93 prev_head
=`git rev-parse HEAD^0`
94 # save the resulting commit so we can read-tree on it later
95 echo "$prev_head" > "$dotest/prev_head"
97 # onto the next patch:
98 msgnum
=$
(($msgnum + 1))
99 echo "$msgnum" >"$dotest/msgnum"
103 cmt
="$(cat "$dotest/cmt.
$1")"
104 echo "$cmt" > "$dotest/current"
105 hd
=$
(git rev-parse
--verify HEAD
)
106 cmt_name
=$
(git symbolic-ref HEAD
2> /dev
/null ||
echo HEAD
)
107 msgnum
=$
(cat "$dotest/msgnum")
108 end
=$
(cat "$dotest/end")
109 eval GITHEAD_
$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
110 eval GITHEAD_
$hd='$(cat "$dotest/onto_name")'
111 export GITHEAD_
$cmt GITHEAD_
$hd
112 if test -n "$GIT_QUIET"
114 export GIT_MERGE_VERBOSITY
=1
116 git-merge-
$strategy "$cmt^" -- "$hd" "$cmt"
120 unset GITHEAD_
$cmt GITHEAD_
$hd
124 git rerere
$allow_rerere_autoupdate
128 echo "Strategy: $rv $strategy failed, try another" 1>&2
132 die
"Unknown exit code ($rv) from command:" \
133 "git-merge-$strategy $cmt^ -- HEAD $cmt"
138 move_to_original_branch
() {
139 test -z "$head_name" &&
140 head_name
="$(cat "$dotest"/head-name)" &&
141 onto
="$(cat "$dotest"/onto)" &&
142 orig_head
="$(cat "$dotest"/orig-head)"
145 message
="rebase finished: $head_name onto $onto"
146 git update-ref
-m "$message" \
147 $head_name $
(git rev-parse HEAD
) $orig_head &&
148 git symbolic-ref HEAD
$head_name ||
149 die
"Could not move back to $head_name"
155 move_to_original_branch
165 interactive_rebase
=explicit
168 -p|
--preserve-merges)
169 interactive_rebase
=implied
175 if [ "$interactive_rebase" = implied
]; then
180 test -n "$interactive_rebase" ||
test -f "$dotest"/interactive
183 run_pre_rebase_hook
() {
184 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
185 test -x "$GIT_DIR/hooks/pre-rebase"
187 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
188 die
"The pre-rebase hook refused to rebase."
192 test -f "$GIT_DIR"/rebase-apply
/applying
&&
193 die
'It looks like git-am is in progress. Cannot rebase.'
195 is_interactive
"$@" && exec git-rebase--interactive
"$@"
199 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
200 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply
/rebasing
&&
201 die
'A rebase is in progress, try --continue, --skip or --abort.'
202 die
"No arguments given and $GIT_DIR/rebase-apply already exists."
209 OK_TO_SKIP_PRE_REBASE
=yes
212 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
213 die
"No rebase in progress?"
215 git diff-files
--quiet --ignore-submodules ||
{
216 echo "You must edit all merge conflicts and then"
217 echo "mark them as resolved using git add"
222 prev_head
=$
(cat "$dotest/prev_head")
223 end
=$
(cat "$dotest/end")
224 msgnum
=$
(cat "$dotest/msgnum")
225 onto
=$
(cat "$dotest/onto")
226 GIT_QUIET
=$
(cat "$dotest/quiet")
228 while test "$msgnum" -le "$end"
236 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
237 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
238 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
239 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
240 git am
--resolved --3way --resolvemsg="$RESOLVEMSG" &&
241 move_to_original_branch
245 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
246 die
"No rebase in progress?"
248 git
reset --hard HEAD ||
exit $?
252 prev_head
=$
(cat "$dotest/prev_head")
253 end
=$
(cat "$dotest/end")
254 msgnum
=$
(cat "$dotest/msgnum")
255 msgnum
=$
(($msgnum + 1))
256 onto
=$
(cat "$dotest/onto")
257 GIT_QUIET
=$
(cat "$dotest/quiet")
258 while test "$msgnum" -le "$end"
266 head_name
=$
(cat "$GIT_DIR"/rebase-apply
/head-name
) &&
267 onto
=$
(cat "$GIT_DIR"/rebase-apply
/onto
) &&
268 orig_head
=$
(cat "$GIT_DIR"/rebase-apply
/orig-head
) &&
269 GIT_QUIET
=$
(cat "$GIT_DIR"/rebase-apply
/quiet
)
270 git am
-3 --skip --resolvemsg="$RESOLVEMSG" &&
271 move_to_original_branch
275 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
276 die
"No rebase in progress?"
281 GIT_QUIET
=$
(cat "$dotest/quiet")
282 move_to_original_branch
284 dotest
="$GIT_DIR"/rebase-apply
285 GIT_QUIET
=$
(cat "$dotest/quiet")
286 move_to_original_branch
288 git
reset --hard $
(cat "$dotest/orig-head")
293 test 2 -le "$#" || usage
297 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
300 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
301 --strateg=*|
--strategy=*|\
302 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
305 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
327 git_am_opt
="$git_am_opt -q"
332 git_am_opt
="$git_am_opt $1"
334 --whitespace=fix|
--whitespace=strip
)
340 git_am_opt
="$git_am_opt $1"
342 --committer-date-is-author-date|
--ignore-date)
343 git_am_opt
="$git_am_opt $1"
347 git_am_opt
="$git_am_opt $1"
352 -f|
--f|
--fo|
--for|
--forc|force|
--force-r|
--force-re|
--force-reb|
--force-reba|
--force-rebas|
--force-rebase)
355 --rerere-autoupdate|
--no-rerere-autoupdate)
356 allow_rerere_autoupdate
="$1"
367 test $# -gt 2 && usage
369 # Make sure we do not have $GIT_DIR/rebase-apply
370 if test -z "$do_merge"
372 if mkdir
"$GIT_DIR"/rebase-apply
2>/dev
/null
374 rmdir "$GIT_DIR"/rebase-apply
377 It seems that I cannot create a rebase-apply directory, and
378 I wonder if you are in the middle of patch application or another
379 rebase. If that is not the case, please
380 rm -fr '"$GIT_DIR"'/rebase-apply
381 and run me again. I am stopping in case you still have something
388 die
"previous rebase directory $dotest still exists." \
389 'Try git rebase (--continue | --abort | --skip)'
393 # The tree must be really really clean.
394 if ! git update-index
--ignore-submodules --refresh > /dev
/null
; then
395 echo >&2 "cannot rebase: you have unstaged changes"
396 git diff-files
--name-status -r --ignore-submodules -- >&2
399 diff=$
(git diff-index
--cached --name-status -r --ignore-submodules HEAD
--)
401 ?
*) echo >&2 "cannot rebase: your index contains uncommitted changes"
407 if test -z "$rebase_root"
409 # The upstream head must be given. Make sure it is valid.
412 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
413 die
"invalid upstream $upstream_name"
415 upstream_arg
="$upstream_name"
417 test -z "$newbase" && die
"--root must be used with --onto"
421 upstream_arg
="$root_flag"
424 # Make sure the branch to rebase onto is valid.
425 onto_name
=${newbase-"$upstream_name"}
428 if left
=${onto_name%...*} right
=${onto_name#*...} &&
429 onto
=$
(git merge-base
--all ${left:-HEAD} ${right:-HEAD})
433 die
"$onto_name: there are more than one merge bases"
436 die
"$onto_name: there is no merge base"
440 die
"$onto_name: there is no merge base"
444 onto
=$
(git rev-parse
--verify "${onto_name}^0") ||
exit
448 # If a hook exists, give it a chance to interrupt
449 run_pre_rebase_hook
"$upstream_arg" "$@"
451 # If the branch to rebase is given, that is the branch we will rebase
452 # $branch_name -- branch being rebased, or HEAD (already detached)
453 # $orig_head -- commit object name of tip of the branch before rebasing
454 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
458 # Is it "rebase other $branchname" or "rebase other $commit"?
462 if git show-ref
--verify --quiet -- "refs/heads/$1" &&
463 branch
=$
(git rev-parse
-q --verify "refs/heads/$1")
465 head_name
="refs/heads/$1"
466 elif branch
=$
(git rev-parse
-q --verify "$1")
468 head_name
="detached HEAD"
474 # Do not need to switch branches, we are already on it.
475 if branch_name
=`git symbolic-ref -q HEAD`
477 head_name
=$branch_name
478 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
480 head_name
="detached HEAD"
481 branch_name
=HEAD
;# detached
483 branch
=$
(git rev-parse
--verify "${branch_name}^0") ||
exit
488 # Now we are rebasing commits $upstream..$branch (or with --root,
489 # everything leading up to $branch) on top of $onto
491 # Check if we are already based on $onto with linear history,
492 # but this should be done only when upstream and onto are the same.
493 mb
=$
(git merge-base
"$onto" "$branch")
494 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
496 ! (git rev-list
--parents "$onto"..
"$branch" | sane_grep
" .* ") > /dev
/null
498 if test -z "$force_rebase"
500 # Lazily switch to the target branch if needed...
501 test -z "$switch_to" || git checkout
"$switch_to"
502 say
"Current branch $branch_name is up to date."
505 say
"Current branch $branch_name is up to date, rebase forced."
509 # Detach HEAD and reset the tree
510 say
"First, rewinding head to replay your work on top of it..."
511 git checkout
-q "$onto^0" || die
"could not detach HEAD"
512 git update-ref ORIG_HEAD
$branch
514 if test -n "$diffstat"
516 if test -n "$verbose"
518 echo "Changes from $mb to $onto:"
520 # We want color (if set), but no pager
521 GIT_PAGER
='' git
diff --stat --summary "$mb" "$onto"
524 # If the $onto is a proper descendant of the tip of the branch, then
525 # we just fast-forwarded.
526 if test "$mb" = "$branch"
528 say
"Fast-forwarded $branch_name to $onto_name."
529 move_to_original_branch
533 if test -n "$rebase_root"
535 revisions
="$onto..$orig_head"
537 revisions
="$upstream..$orig_head"
540 if test -z "$do_merge"
542 git format-patch
-k --stdout --full-index --ignore-if-in-upstream \
543 $root_flag "$revisions" |
544 git am
$git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
545 move_to_original_branch
547 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply
&&
548 echo $head_name > "$GIT_DIR"/rebase-apply
/head-name
&&
549 echo $onto > "$GIT_DIR"/rebase-apply
/onto
&&
550 echo $orig_head > "$GIT_DIR"/rebase-apply
/orig-head
&&
551 echo "$GIT_QUIET" > "$GIT_DIR"/rebase-apply
/quiet
555 # start doing a rebase with git-merge
556 # this is rename-aware if the recursive (default) strategy is used
559 echo "$onto" > "$dotest/onto"
560 echo "$onto_name" > "$dotest/onto_name"
562 echo "$prev_head" > "$dotest/prev_head"
563 echo "$orig_head" > "$dotest/orig-head"
564 echo "$head_name" > "$dotest/head-name"
565 echo "$GIT_QUIET" > "$dotest/quiet"
568 for cmt
in `git rev-list --reverse --no-merges "$revisions"`
570 msgnum
=$
(($msgnum + 1))
571 echo "$cmt" > "$dotest/cmt.$msgnum"
574 echo 1 >"$dotest/msgnum"
575 echo $msgnum >"$dotest/end"
580 while test "$msgnum" -le "$end"